Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package ast
  Definition Classes
    nsc
-  package parser
  Definition Classes
    ast
-  trait Scanners extends ScannersCommon
  Definition Classes
    parser
- CommonTokenData
- DocScanner
- MalformedInput
- ParensAnalyzer
- Scanner
- ScannerCommon
- ScannerData
- SourceFileScanner
- TokenData
- UnitScanner

c

scala.tools.nsc.ast.parser.Scanners

# Scanner

###

#### abstract class Scanner extends CharArrayReader with TokenData with ScannerData with ScannerCommon with DocScanner

Source
  Scanners.scala

Linear Supertypes
Scanners.DocScanner, Scanners.ScannerCommon, ScannerData, TokenData, Scanners.CommonTokenData, CharArrayReader, CharArrayReaderData, AnyRef, Any
Known Subclasses
ParensAnalyzer, SourceFileScanner, UnitScanner, ScaladocUnitScanner
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Scanner
2. DocScanner
3. ScannerCommon
4. ScannerData
5. TokenData
6. CommonTokenData
7. CharArrayReader
8. CharArrayReaderData
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Scanner()

### Type Members

1.  class CharArrayLookaheadReader extends CharArrayReader
   Definition Classes
     CharArrayReader

### Abstract Value Members

1.  abstract val buf: Array[Char]
   Definition Classes
     CharArrayReader
2.  abstract def deprecationWarning(off: Scanners.Offset, msg: String, since: String): Unit
   Definition Classes
     ScannerCommon
3.  abstract def error(off: Scanners.Offset, msg: String): Unit
   Definition Classes
     ScannerCommon
4.  abstract def incompleteInputError(off: Scanners.Offset, msg: String): Unit
   Definition Classes
     ScannerCommon

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Scanner toany2stringadd[Scanner] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Scanner, B)
   Implicit
     This member is added by an implicit conversion from Scanner toArrowAssoc[Scanner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def applyBracePatch(): Boolean

   overridden in UnitScanners: apply brace patch if one exists for this offset return true if subsequent end of line handling should be suppressed.

7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  val base: Int

   the base of a number

   the base of a number

   Definition Classes
     TokenData
9.  def beginDocComment(prefix: String): Unit
   Attributes
     protected
   Definition Classes
     DocScanner
10.  val cbuf: collection.mutable.StringBuilder

    A character buffer for literals

11.  val ch: Char

    the last read character

    the last read character

    Definition Classes
      CharArrayReaderData
12.  def charLitOr(op: () => Unit): Unit

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

13.  val charOffset: Int

    The offset one past the last read character

    The offset one past the last read character

    Definition Classes
      CharArrayReaderData
14.  def charVal: Char

    Convert current strVal to char value

15.  def checkNoLetter(): Unit
16.  def checkNoTrailingSeparator(): Unit
17.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
18.  def copyFrom(sd: ScannerData): Scanner.this.type
    Definition Classes
      ScannerData
19.  def copyFrom(td: TokenData): Scanner.this.type
    Definition Classes
      TokenData
20.  def copyFrom(cd: CharArrayReaderData): Scanner.this.type
    Definition Classes
      CharArrayReaderData
21.  def decodeUni: Boolean
    Definition Classes
      CharArrayReader
22.  def deprecationWarning(msg: String, since: String): Unit
23.  def discardDocBuffer(): Unit

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    Definition Classes
      DocScanner
24.  def doubleVal: Double
25.  def doubleVal(negated: Boolean): Double

    Convert current strVal, base to double value.

26.  def emitIdentifierDeprecationWarnings: Boolean

    Determines whether this scanner should emit identifier deprecation warnings, e.g.

    Determines whether this scanner should emit identifier deprecation warnings, e.g. when seeing `macro` or `then`, which are planned to become keywords in future versions of Scala.

    Attributes
      protected
27.  def ensuring(cond: (Scanner) => Boolean, msg: => Any): Scanner
    Implicit
      This member is added by an implicit conversion from Scanner toEnsuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
28.  def ensuring(cond: (Scanner) => Boolean): Scanner
    Implicit
      This member is added by an implicit conversion from Scanner toEnsuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
29.  def ensuring(cond: Boolean, msg: => Any): Scanner
    Implicit
      This member is added by an implicit conversion from Scanner toEnsuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
30.  def ensuring(cond: Boolean): Scanner
    Implicit
      This member is added by an implicit conversion from Scanner toEnsuring[Scanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
31.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
32.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
33.  final def fetchToken(): Unit

    read next token, filling TokenData fields of Scanner.

    read next token, filling TokenData fields of Scanner.

    Attributes
      protected
    Annotations
      @tailrec()
34.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
35.  def finishDocComment(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
36.  def floatVal: Float
37.  def floatVal(negated: Boolean): Float

    Convert current strVal, base to float value.

38.  def flushDoc(): Global.DocComment
    Definition Classes
      DocScanner
39.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Scanner toStringFormat[Scanner] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
40.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
41.  def getFraction(): Unit

    read fractional part and exponent of floating point number if one is present.

    read fractional part and exponent of floating point number if one is present.

    Attributes
      protected
42.  def getLitChar(): Unit

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    Attributes
      protected
43.  def getNumber(): Unit

    Read a number into strVal.

    Read a number into strVal.

    The `base` can be 8, 10 or 16, where base 8 flags a leading zero. For ints, base 8 is legal only for the case of exactly one zero.

    Attributes
      protected
44.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
45.  def healBraces(): List[BracePatch]

    overridden in UnitScanners

46.  def inFirstOfStat(token: Scanners.Token): Boolean

    Can token start a statement?

47.  def inLastOfStat(token: Scanners.Token): Boolean

    Can token end a statement?

48.  def incompleteInputError(msg: String): Unit

    signal an error where the input ended in the middle of a token

49.  def init(): Unit

    Initialization method: read first char, then first token

50.  def intVal: Long
51.  def intVal(negated: Boolean): Long

    Convert current strVal, base to long value.

    Convert current strVal, base to long value. This is tricky because of max negative value.

    Conversions in base 10 and 16 are supported. As a permanent migration path, attempts to write base 8 literals except `0` emit a verbose error.

52.  def invalidEscape(): Unit
    Attributes
      protected
53.  def isAtEnd: Boolean
54.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
55.  def isUnicodeEscape: Boolean

    Is last character a unicode escape \\uxxxx?

    Is last character a unicode escape \\uxxxx?

    Definition Classes
      CharArrayReader
56.  val lastLineStartOffset: Int

    The start offset of the line before the current one

    The start offset of the line before the current one

    Definition Classes
      CharArrayReaderData
57.  val lastOffset: Scanners.Offset

    the offset of the character following the token preceding this one

    the offset of the character following the token preceding this one

    Definition Classes
      TokenData
58.  val lastUnicodeOffset: Int
    Attributes
      protected
    Definition Classes
      CharArrayReaderData
59.  val lineStartOffset: Int

    The start offset of the current line

    The start offset of the current line

    Definition Classes
      CharArrayReaderData
60.  def lookaheadReader: CharArrayLookaheadReader

    A new reader that takes off at the current character position

    A new reader that takes off at the current character position

    Definition Classes
      CharArrayReader
61.  val name: Global.TermName

    the name of an identifier

    the name of an identifier

    Definition Classes
      TokenData → CommonTokenData
62.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
63.  val next: TokenData

    we need one token lookahead and one token history

    we need one token lookahead and one token history

    Definition Classes
      ScannerData
64.  final def nextChar(): Unit

    Advance one character; reducing CR;LF pairs to just LF

    Advance one character; reducing CR;LF pairs to just LF

    Definition Classes
      CharArrayReader
65.  final def nextRawChar(): Unit

    Advance one character, leaving CR;LF pairs intact.

    Advance one character, leaving CR;LF pairs intact. This is for use in multi-line strings, so there are no "potential line ends" here.

    Definition Classes
      CharArrayReader
66.  def nextToken(): Unit

    Produce next token, filling TokenData fields of Scanner.

67.  def nextTokenAllow(name: Global.Name): Unit

    Get next token, and allow the otherwise deprecated ident `name`

68.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
69.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
70.  val offset: Scanners.Offset

    the offset of the first character of the current token

    the offset of the first character of the current token

    Definition Classes
      TokenData
71.  def parenBalance(token: Scanners.Token): Int

    overridden in UnitScanners

72.  val prev: TokenData
    Definition Classes
      ScannerData
73.  def processCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
74.  def putChar(c: Char): Unit

    append Unicode character to "cbuf" buffer

    append Unicode character to "cbuf" buffer

    Attributes
      protected
75.  final def putCommentChar(): Unit
    Attributes
      protected
76.  def registerDocComment(raw: String, pos: Global.Position): Unit
    Definition Classes
      DocScanner
77.  def resume(lastCode: Scanners.Token): Unit
78.  var sepRegions: List[Scanners.Token]

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels.

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels. We keep track of the closing symbol of a region. This can be RPAREN if region starts with '(' RBRACKET if region starts with '[' RBRACE if region starts with '{' ARROW if region starts with 'case' STRINGLIT if region is a string interpolation expression starting with '${' (the STRINGLIT appears twice in succession on the stack iff the expression is a multiline string literal).

79.  final def skipComment(): Boolean

80.  final def skipNestedComments(): Unit
    Annotations
      @tailrec()
81.  def skipToken(): Scanners.Offset

    read next token and return last offset

82.  val strVal: String

    the string value of a literal

    the string value of a literal

    Definition Classes
      TokenData
83.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
84.  def syntaxError(msg: String): Unit

    generate an error at the current token offset

85.  def syntaxError(off: Scanners.Offset, msg: String): Unit

    generate an error at the given offset

86.  def toString(): String
    Definition Classes
      Scanner → AnyRef → Any
87.  val token: Scanners.Token

    the next token

    the next token

    Definition Classes
      TokenData → CommonTokenData
88.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
89.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
90.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (Scanner, B)
   Implicit
     This member is added by an implicit conversion from Scanner toArrowAssoc[Scanner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Scanners.DocScanner

### Inherited from Scanners.ScannerCommon

### Inherited from ScannerData

### Inherited from TokenData

### Inherited from Scanners.CommonTokenData

### Inherited from CharArrayReader

### Inherited from CharArrayReaderData

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromScanner to any2stringadd[Scanner]

### Inherited by implicit conversion StringFormat fromScanner to StringFormat[Scanner]

### Inherited by implicit conversion Ensuring fromScanner to Ensuring[Scanner]

### Inherited by implicit conversion ArrowAssoc fromScanner to ArrowAssoc[Scanner]

### Ungrouped